-- @Name Base
-- @Type parent
property pImage
property pLoc
property pRegpoint
property pFlipH
property pRemoveMe --Bool if this object should be deleted from the gameobject list.
property pType

on new me
  pScale = 2
  pRegpoint = point(16,32)
  pLoc = point(0,0)
  pFlipH = false
  pRemoveMe = false
  
  pType = #base
  return me
end

on render me, aImg, aOffset, aOptions
  
  vLoc = aOffset + pLoc - pRegpoint
  
  vSrcRect = pImage.rect
  vTrg = offset( vSrcRect, integer(vLoc.loch ), integer( vLoc.locv ) )
  
  if pFlipH then
    --Make a flipped quad from the rect
    vTrg = [ point(vTrg[3], vTrg[2]), point(vTrg[1], vTrg[2]) , point(vTrg[1], vTrg[4])  , point(vTrg[3], vTrg[4])  ]
  end if
  aImg.copyPixels( pImage, vTrg, vSrcRect, aOptions )
  
end

on EnterFrame me, aTime
  --Interface only
end

on terminate me
  pImage = void 
  pLoc = void
  pRegpoint = void
end

on SetRemoveMe (me, bool)
  me.pRemoveMe = bool
end
