-- @Name Flower
-- @Type parent
property ancestor
property pTime
property pTimeToNextLevel
property pIsFertelized
property pSpeed

on new me
  global gGame
  
  me.ancestor = script("anim").new()
  
  me.pTime = 0
  me.pType = #flower
  me.pSpeed = gGame.GetFlowerSpeed()
  me.pIsFertelized = false
  
  me.SetAnim("Flower")
  me.PauseAnim()  
  me.ExtendTime()
  
  return me
end

on SetSpeed me, aSpeed
  me.pSpeed = aSpeed
end

on ExtendTime me  
  
  if pIsFertelized then
    pTimeToNextLevel = (pSpeed/2) + random( pSpeed/10 )
  else
    pTimeToNextLevel = pSpeed     + random( pSpeed/10 )
  end if  
end

on Fertelize me
  pIsFertelized = true

end

on Mow me
  
  vResult = [#type:#useless,#value:0]
  
  if me.pFrame = 10 then
    vResult.type = #flower
    vResult.value = 1
  end if
  
  if me.pFrame = 11 then
    vResult.type = #flower
    vResult.value = 2
  end if 
  
  if me.pFrame = 12 then
    vResult.type = #seeds
    vResult.value = 2
  end if 
  
  if me.pFrame = 13 then
    vResult.type = #seeds
    vResult.value = 3
  end if  
  
  if me.pFrame = 14 then
    vResult.type = #fertelizer
    vResult.value = 1
  end if  
  
  if me.pFrame = 15 then
    vResult.type = #fertelizer
    vResult.value = 2
  end if  
  
  me.SetRemoveMe(true)
  
  return vResult
end

on render me, aImg, aOffset, aOptions  
  
  if pIsFertelized then
    aOptions[#forecolor] = rgb(255,0,0).paletteindex
  end if
  
  me.ancestor.render( aImg, aOffset, aOptions )
end

on enterframe me, aTime
  
  pTime = pTime + aTime
  
  if pTime > pTimeToNextLevel then 
    pTime  = 0
    me.NextFrame()
    
  end if
  
end

on NextFrame me
  
  if me.pFrame = 15 then
    me.SetRemoveMe(true)
    
  else
    me.ancestor.NextFrame()
    
    me.ExtendTime()
  end if
  
end

