-- @Name Levels
-- @Type movie
global gGame, gPlayer

on CreateLevel Level  
  
  sound(1).fadeOut(1000) 
  
  sound(2).play(member("Wind"))
  sound(2).volume = 50
  sound(2).fadeIn(1000)
  
  
  gGame.Reset()
  gGame.pLevel = Level
  
  --BACKGROUND
  vBG = script("base").new() 
  vBG.pImage = member("bg01").image
  vBG.pRegPoint = point(0,0)  
  gGame.pObjects.append( vBG )
  
  --CLOUDS
  vCloud = script("cloud").new()
  vCloud.SetAnim("SmallCloud")
  vCloud.SetPace( -0.05 )
  vCloud.pLoc = point( random(-100,420) ,130)  
  gGame.pObjects.append( vCloud )  
  
  vCloud = script("cloud").new()
  vCloud.SetAnim("SmallCloud")
  vCloud.SetPace( -0.04 )  
  vCloud.pLoc = point( random(-100,420) ,140)    
  gGame.pObjects.append( vCloud )  
  
  vCloud = script("cloud").new() 
  vCloud.pLoc = point( random(-100,420) ,100)  
  gGame.pObjects.append( vCloud )
  
  
  --PLAYER
  gPlayer = script("player").new()  
  gPlayer.pLoc = point(160,120)
  
  gGame.pObjects.append( gPlayer )
  
  --STAND
  vStand = script("Anim").new() 
  vStand.SetAnim("Stand")  
  vStand.pType = #stand
  vStand.pLoc = point(300,184)  
  gGame.pObjects.append( vStand )
  
  case Level of
    1:
      Level1()
    2:
      Level2()   
    3:
      Level3()      
    4:
      Level4()
    5:
      Level5()   
    6:
      Level6()      
    7:
      Level7()       
    8:
      Level8()       
    9:
      Level9()
      
    10:
      Level10() 
      
    otherwise:      
      LevelGeneric( Level )
  end case
  
end

on Level1
  
  gPlayer.pSeeds = 1  
  gGame.pRules.pFlowersNeeded = 1  
  gGame.pLevelName = "KINDERGARDEN"
  gGame.pFlowerSpeed = 1000
  
  
end

on Level2
  
  gPlayer.pSeeds = 1  
  gGame.pRules.pFlowersNeeded = 3
  
  
  gGame.pLevelName = "PLANT SCHOOL"
  gGame.pFlowerSpeed = 1000
  
end

on Level3
  
  gPlayer.pSeeds = 3  
  gGame.pRules.pMoneyNeeded = 3
  gGame.pLevelName = "MAKING MONEY"
  gGame.pFlowerSpeed = 1000
  
end

on Level4
  
  gPlayer.pSeeds = 6  
  gGame.pRules.pFlowersNeeded = 3
  gGame.pRules.pMoneyNeeded = 3
  gGame.pLevelName = "FLOWER N MONEY"
  gGame.pFlowerSpeed = 1000
  
end

on Level5
  
  gPlayer.pSeeds = 3  
  gGame.pRules.pSeedsNeeded = 30
  gGame.pLevelName = "SEEEEEEDS"
  gGame.pFlowerSpeed = 700  
  
end

on Level6
  
  gPlayer.pSeeds = 7  
  gGame.pRules.pMoneyNeeded = 15  
  gGame.pLevelName = "NEED TO BREED"
  gGame.pFlowerSpeed = 1000
  
end

on Level7  
  gPlayer.pSeeds = 7  
  gGame.pRules.pFertelizersNeeded = 15
  gGame.pLevelName = "FERTELIZE RUN"
  --gGame.pFlowerSpeed = 1000
  
end  

on Level8  
  
  gGame.pLevelName = "ONE OF EACH"
  
  gPlayer.pSeeds = 3  
  gGame.pRules.pSeedsNeeded = 1
  gGame.pRules.pFertelizersNeeded = 1
  gGame.pRules.pFlowersNeeded = 1
  gGame.pRules.pMoneyNeeded = 1
  
  gGame.pFlowerSpeed = 1000
  
end


on Level9 
  
  gGame.pLevelName = "BUGS ARE COMING"
  
  gPlayer.pSeeds = 3  
  gGame.pRules.pSeedsNeeded = 10
  
  gGame.pFlowerSpeed = 1800
  
  --Bug
  vBug = script("bug").new()  
  vBug.pLoc = point(-500,120) 
  vBug.pFlipH = true
  vBug.pSpeedLimit = 2.5
  gGame.pObjects.append( vBug )
  
  vBug = script("bug").new()  
  vBug.pLoc = point(-1000,120) 
  vBug.pFlipH = true
  vBug.pSpeedLimit = 2.5
  gGame.pObjects.append( vBug )
  
end

on Level10 
  
  gGame.pLevelName = "INVASION"
  
  gPlayer.pSeeds = 1  
  gGame.pRules.pSeedsNeeded = 10
  
  gGame.pFlowerSpeed = 1800
  
  --Bug 
  
  vBugs = 10
  repeat with i = 1 to vBugs
    vBug = script("bug").new()  
    vBug.pLoc = point(random(-1000, 1000) ,120) 
    vBug.pFlipH = random(0,1)
    vBug.pSpeedLimit = 2.5
    gGame.pObjects.append( vBug )
  end repeat
  
end

on LevelGeneric ( Level )
  
  gGame.pLevelName = "GENERIC"
  
  gPlayer.pSeeds = 3
  
  gGame.pRules.pFlowersNeeded     = 1+ random(0,1) * random( Level )
  gGame.pRules.pFertelizersNeeded = random(0,1) * random( Level )  
  gGame.pRules.pSeedsNeeded       = random(0,1) * random( Level )
  gGame.pRules.pMoneyNeeded       = random(0,1) * random( Level*2 )
  
  vBugs = random(0,1) * random( Level*2 )
  repeat with i = 1 to vBugs
    vBug = script("bug").new()  
    vBug.pLoc = point(random(-1000, 1000) ,120) 
    vBug.pFlipH = random(0,1)
    vBug.pSpeedLimit = min(8, 2.5 + (Level/10.0))
    gGame.pObjects.append( vBug )
  end repeat
  
end