-- @Name Rules
-- @Type parent
global gGame, gPlayer, gAnim, gText

property pTimelimit
property pFlowersNeeded
property pMoneyNeeded
property pFertelizersNeeded
property pSeedsNeeded

on new me
  
  pTimelimit = 0
  pFlowersNeeded = 0
  pMoneyNeeded = 0
  pFertelizersNeeded = 0
  pSeedsNeeded = 0
  
  return me
end

on CheckWin me
  
  vWin = true
  
  if pFlowersNeeded > 0 then
    if gPlayer.pFlowers < pFlowersNeeded then vWin = false
    
  end if
  
  if pMoneyNeeded > 0 then
    if gPlayer.pMoney < pMoneyNeeded then vWin = false
    
  end if
  
  if pFertelizersNeeded > 0 then
    if gPlayer.pFertelizer < pFertelizersNeeded then vWin = false
    
  end if
  
  if pSeedsNeeded > 0 then
    if gPlayer.pSeeds < pSeedsNeeded then vWin = false
    
  end if
  
  Return vWin
  
end

on CheckSomethingToDo me
  if gPlayer.pSeeds > 0 then return true
  if gPlayer.pFlowers > 0 then return true
  
  repeat with vObj in gGame.pObjects
    if vObj.pType = #flower then return true
  end repeat
  
  --No seeds, no flowers left. nothing to do, end level. fail.
  return false
end

on Render me, aImg, aLoc
  if voidP( gPlayer ) then return
  
  vNeededCount = 0
  
  if pFlowersNeeded     > 0 then vNeededCount = vNeededCount + 1  
  if pMoneyNeeded       > 0 then vNeededCount = vNeededCount + 1  
  if pFertelizersNeeded > 0 then vNeededCount = vNeededCount + 1
  if pSeedsNeeded       > 0 then vNeededCount = vNeededCount + 1
  
  vY = aLoc.locv
  vX = aLoc.loch + 10
  
  
  --bg  
  vRect = gAnim["LevelBG"][1].rect
  aImg.copyPixels( gAnim["LevelBG"][1], offset(vRect,vX,vY), vRect, [#ink: #backgroundtransparent] )
  
  vIconRect = gAnim["FlowerIcon"][1].rect
  
  vY = vY + 10
  --Level
  gText.Render( aImg, point(vX +7,vY), gGame.pLevel & " " & gGame.pLevelName )
  
  vY = vY + 10   
  gText.Render( aImg, point(vX + 30,vY+10), "RESOURCES" )
  vY = vY + 20  
  vX = vX + 20
  
  --RESOURCES
  
  vX2 = vX-20
  if gPlayer.pFlowers > -10 then
    aImg.copyPixels( gAnim["FlowerIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(gPlayer.pFlowers) )
    --vY = vY + 20
    vX2 = vX2 + 30
  end if
  
  if gPlayer.pMoney > -10 then
    aImg.copyPixels( gAnim["CoinIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(gPlayer.pMoney) )
    --vY = vY + 20
    vX2 = vX2 + 30
  end if
  
  if gPlayer.pFertelizer > -10 then
    aImg.copyPixels( gAnim["FertelizerIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(gPlayer.pFertelizer) )
    --vY = vY + 20
    vX2 = vX2 + 30
  end if
  
  if gPlayer.pSeeds > -10 then
    aImg.copyPixels( gAnim["SeedIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(gPlayer.pSeeds) )
    --vY = vY + 20
    vX2 = vX2 + 30
    
  end if
  
  
  vY = vY + 10
  
  gText.Render( aImg, point(vX ,vY+10), "ITEMS NEEDED" )
  
  vY = vY + 20
  
  --vX = vX + 20
  
  --Rules
  
  vX2 = vX-20
  if pFlowersNeeded > -10 then
    aImg.copyPixels( gAnim["FlowerIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(pFlowersNeeded) )
    --vY = vY + 20
    vX2 = vX2 + 30   
  end if
  
  if pMoneyNeeded > -10 then
    aImg.copyPixels( gAnim["CoinIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(pMoneyNeeded) )
    --vY = vY + 20
    vX2 = vX2 + 30
    
  end if
  
  if pFertelizersNeeded > -10 then
    aImg.copyPixels( gAnim["FertelizerIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(pFertelizersNeeded) )
    --vY = vY + 20
    vX2 = vX2 + 30
  end if
  
  if pSeedsNeeded > -10 then
    aImg.copyPixels( gAnim["SeedIcon"][1], offset(vIconRect,vX2 + 10,vY), vIconRect, [#ink: #backgroundtransparent] )
    gText.Render( aImg, point(vX2+22,vY+2), string(pSeedsNeeded) )
    --vY = vY + 20
    vX2 = vX2 + 30
    
  end if
  
  
  gText.Render( aImg, point(aLoc.loch + 35 , aLoc.locv+ 105), "PRESS SPACE" )
end

on RenderResult me, aImg, aLoc
  if voidP( gGame ) then return
  
  vY = aLoc.locv
  vX = aLoc.loch + 10
  
  --bg  
  vRect = gAnim["LevelBG"][1].rect
  aImg.copyPixels( gAnim["LevelBG"][1], offset(vRect,vX,vY), vRect, [#ink: #backgroundtransparent] )
  
  
  vY = vY + 10
  --Level
  gText.Render( aImg, point(vX +7,vY), gGame.pLevel & " " & gGame.pLevelName )
  
  vY = vY + 10
  
  if me.CheckWin() then
    gText.Render( aImg, point(vX + 50,vY+10), "WON" )
  else
    gText.Render( aImg, point(vX + 50,vY+10), "LOST" )
  end if
  
  gText.Render( aImg, point(aLoc.loch + 35 , aLoc.locv+ 105), "PRESS SPACE" )
  
end