-- @Name StateMachine
-- @Type parent
property pCurrentState
property pStates

on new me, BeginState  
  me.Init()
  me.SetState( BeginState )
  return me
end

on Init (me)
  pStates = [:]
end

on SetState(me, StateName )
  
  --Make transition
  if not voidP( pCurrentState ) then
    if not voidP( pStates[pCurrentState] ) then
      pStates[pCurrentState].Stop()
    end if
  end if
  
  
  pCurrentState = StateName
  
  if voidP( pStates[pCurrentState] ) then
    --create stateobject
    pStates.addProp( pCurrentState, script( "State_"& pCurrentState ).new() )
  end if
  
  pStates[pCurrentState].Start()
end

on stop me
  call #stop, pStates
  pStates = void
end

on enterframe me
  if not voidP( pCurrentState ) then
    if not voidP( pStates[pCurrentState] ) then
      pStates[pCurrentState].enterframe()
    end if
  end if  
end

on KeyUp me  
  if not voidP( pCurrentState ) then
    if not voidP( pStates[pCurrentState] ) then
      pStates[pCurrentState].KeyUp()
    end if
  end if 
end

on KeyDown me  
  if not voidP( pCurrentState ) then
    if not voidP( pStates[pCurrentState] ) then
      pStates[pCurrentState].KeyDown()
    end if
  end if 
end