-- @Name bug
-- @Type parent
property ancestor
property pIsDead
property pHasPlant

on new me
  global gGame
  
  me.ancestor = script("player").new()
  
  me.pType = #bug  
  pIsDead = false
  pHasPlant = false
  me.SetAnim("bug")
  
  return me
end

on EnterFrame me, aTime
  
  if not pIsDead then
    
    vInRange = me.GetObjectsInRange(5,20)
    repeat with vObj in vInRange
      
      if me.pHasPlant = false then
        
        if vObj.pType = #flower then
          
          if vObj.pFrame < 7 then
            --Found Food!
            vObj.SetRemoveMe( true )
            me.pFlipH = not me.pFlipH 
            pHasPlant = true
          end if        
        end if
        
      end if
      
      if vObj.pType = #player then
        
        if vObj.pOnGround then --SteelSeed and Flee!
          
          if me.pHasPlant = false then
            if vObj.SteelSeed() then
              
              me.pHasPlant = true
              
            end if            
          end if
          
          if vObj.pLoc.loch < me.pLoc.locH then
            me.pFlipH = true
          else
            me.pFlipH = false
          end if
        end if
        
      end if
      
    end repeat
    
    if me.pLoc.loch < -1000 or me.pLoc.loch > 320+1000 then
      --turn back to garden, drop the plant
      if me.pLoc.loch < 0 then
        me.pFlipH = true
      else
        me.pFlipH = false
      end if      
      
      pHasPlant = false
    end if
    
    me.pVel.loch = max( -me.pSpeedLimit, min( me.pSpeedLimit, me.pVel.loch + [-1,1][me.pFlipH+1] / me.pGroundAcc))
    
  else
    --is dead
    
    pIsDead = pIsDead + 1
    
    me.SetAnim("bugdead")
    me.PauseAnim()
    me.pFrame = 1
    
    if pIsDead > 10 then me.pFrame = 2
    
    if pIsDead > 30*5 then me.SetRemoveMe( true ) --remove after 5 sec
    
  end if
  
  me.ancestor.EnterFrame( aTime )
  
end
